#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <unistd.h>

int
main (int argc, char *argv[])
{
  FILE *infile, *outfile;
  int accNo;
  char name[21];
  float balance;
  if ((infile = fopen ("clients.dat", "r")) == NULL)
    {
      perror ("Error opening clients.dat");
      exit (1);
    }
  if ((outfile = fopen ("clients.new", "w")) == NULL)
    {
      perror ("Error opening clients.new");
      exit (2);
    }
  while (1)
    {
      char *tname;
      int args = fscanf (infile, "%d %20s %f", &accNo, name, &balance);
      if (args == EOF)
	break;
      if (args != 3)
	{
	  fprintf (stderr, "Error in clients.dat");
	  exit (3);
	}
      if (strcmp (name, "Barry"))
	tname = name;
      else			/* replace Barry with Barrett */
	tname = "Barrett";
      if (fprintf (outfile, "%d %s %.2f\n", accNo, tname, balance) < 0)
	{
	  perror ("Error writing data to clients.new");
	  exit (4);
	}
    }

  if (fclose (infile) != 0)
    {
      perror ("Error closing clients.dat");
      exit (5);
    }

  if (fclose (outfile) != 0)
    {
      perror ("Error closing clients.new");
      exit (6);
    }

  if (unlink ("clients.dat"))
    {
      perror ("Cannot delete clients.dat");
      exit (7);
    }

  if (rename ("clients.new", "clients.dat"))
    {
      perror ("Cannot rename clients.new");
      exit (8);
    }

  return 0;
}
